/* AppListRow.c generated by valac 0.46.10, the Vala compiler
 * generated from AppListRow.vala, do not modify */

/*
 * Copyright 2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gdesktopappinfo.h>
#include <gio/gio.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>

#define TYPE_APP_LIST_ROW (app_list_row_get_type ())
#define APP_LIST_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APP_LIST_ROW, AppListRow))
#define APP_LIST_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APP_LIST_ROW, AppListRowClass))
#define IS_APP_LIST_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APP_LIST_ROW))
#define IS_APP_LIST_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APP_LIST_ROW))
#define APP_LIST_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APP_LIST_ROW, AppListRowClass))

typedef struct _AppListRow AppListRow;
typedef struct _AppListRowClass AppListRowClass;
typedef struct _AppListRowPrivate AppListRowPrivate;
enum  {
	APP_LIST_ROW_0_PROPERTY,
	APP_LIST_ROW_APP_ID_PROPERTY,
	APP_LIST_ROW_DESKTOP_PATH_PROPERTY,
	APP_LIST_ROW_APP_INFO_PROPERTY,
	APP_LIST_ROW_NUM_PROPERTIES
};
static GParamSpec* app_list_row_properties[APP_LIST_ROW_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _AppListRow {
	GtkListBoxRow parent_instance;
	AppListRowPrivate * priv;
};

struct _AppListRowClass {
	GtkListBoxRowClass parent_class;
};

struct _AppListRowPrivate {
	gchar* _app_id;
	gchar* _desktop_path;
	GDesktopAppInfo* _app_info;
};

static gint AppListRow_private_offset;
static gpointer app_list_row_parent_class = NULL;

GType app_list_row_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppListRow, g_object_unref)
AppListRow* app_list_row_new (const gchar* app_id,
                              const gchar* desktop_path);
AppListRow* app_list_row_construct (GType object_type,
                                    const gchar* app_id,
                                    const gchar* desktop_path);
void app_list_row_launch (AppListRow* self);
GDesktopAppInfo* app_list_row_get_app_info (AppListRow* self);
const gchar* app_list_row_get_app_id (AppListRow* self);
static void app_list_row_set_app_id (AppListRow* self,
                              const gchar* value);
const gchar* app_list_row_get_desktop_path (AppListRow* self);
static void app_list_row_set_desktop_path (AppListRow* self,
                                    const gchar* value);
static void app_list_row_set_app_info (AppListRow* self,
                                GDesktopAppInfo* value);
static GObject * app_list_row_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void app_list_row_finalize (GObject * obj);
static void _vala_app_list_row_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_app_list_row_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);

static inline gpointer
app_list_row_get_instance_private (AppListRow* self)
{
	return G_STRUCT_MEMBER_P (self, AppListRow_private_offset);
}

AppListRow*
app_list_row_construct (GType object_type,
                        const gchar* app_id,
                        const gchar* desktop_path)
{
	AppListRow * self = NULL;
	g_return_val_if_fail (app_id != NULL, NULL);
	g_return_val_if_fail (desktop_path != NULL, NULL);
	self = (AppListRow*) g_object_new (object_type, "app-id", app_id, "desktop-path", desktop_path, NULL);
	return self;
}

AppListRow*
app_list_row_new (const gchar* app_id,
                  const gchar* desktop_path)
{
	return app_list_row_construct (TYPE_APP_LIST_ROW, app_id, desktop_path);
}

void
app_list_row_launch (AppListRow* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		GDesktopAppInfo* _tmp0_;
		_tmp0_ = self->priv->_app_info;
		g_app_info_launch ((GAppInfo*) _tmp0_, NULL, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch11_g_error;
		}
	}
	goto __finally11;
	__catch11_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
		_error_ = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp1_ = _error_;
		_tmp2_ = _tmp1_->message;
		g_critical ("AppListRow.vala:65: %s", _tmp2_);
		_g_error_free0 (_error_);
	}
	__finally11:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

const gchar*
app_list_row_get_app_id (AppListRow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_app_id;
	result = _tmp0_;
	return result;
}

static void
app_list_row_set_app_id (AppListRow* self,
                         const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, app_list_row_get_app_id (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_app_id);
		self->priv->_app_id = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, app_list_row_properties[APP_LIST_ROW_APP_ID_PROPERTY]);
	}
}

const gchar*
app_list_row_get_desktop_path (AppListRow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_desktop_path;
	result = _tmp0_;
	return result;
}

static void
app_list_row_set_desktop_path (AppListRow* self,
                               const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, app_list_row_get_desktop_path (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_desktop_path);
		self->priv->_desktop_path = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, app_list_row_properties[APP_LIST_ROW_DESKTOP_PATH_PROPERTY]);
	}
}

GDesktopAppInfo*
app_list_row_get_app_info (AppListRow* self)
{
	GDesktopAppInfo* result;
	GDesktopAppInfo* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_app_info;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
app_list_row_set_app_info (AppListRow* self,
                           GDesktopAppInfo* value)
{
	g_return_if_fail (self != NULL);
	if (app_list_row_get_app_info (self) != value) {
		GDesktopAppInfo* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_app_info);
		self->priv->_app_info = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, app_list_row_properties[APP_LIST_ROW_APP_INFO_PROPERTY]);
	}
}

static GObject *
app_list_row_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AppListRow * self;
	const gchar* _tmp0_;
	GDesktopAppInfo* _tmp1_;
	GDesktopAppInfo* _tmp2_;
	GIcon* icon = NULL;
	GDesktopAppInfo* _tmp3_;
	GIcon* _tmp4_;
	GIcon* _tmp5_;
	GtkIconTheme* theme = NULL;
	GtkIconTheme* _tmp6_;
	GtkIconTheme* _tmp7_;
	GIcon* _tmp8_;
	GtkIconInfo* _tmp9_;
	GtkIconInfo* _tmp10_;
	gboolean _tmp11_;
	GtkImage* image = NULL;
	GtkImage* _tmp13_;
	GtkImage* _tmp14_;
	GIcon* _tmp15_;
	GtkImage* _tmp16_;
	GtkLabel* name_label = NULL;
	GDesktopAppInfo* _tmp17_;
	const gchar* _tmp18_;
	GtkLabel* _tmp19_;
	GtkLabel* _tmp20_;
	GtkLabel* _tmp21_;
	GDesktopAppInfo* _tmp22_;
	const gchar* _tmp23_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp24_;
	GtkGrid* _tmp25_;
	GtkGrid* _tmp26_;
	GtkImage* _tmp27_;
	GtkGrid* _tmp28_;
	GtkLabel* _tmp29_;
	GtkGrid* _tmp30_;
	GtkGrid* _tmp31_;
	GtkGrid* _tmp32_;
	parent_class = G_OBJECT_CLASS (app_list_row_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APP_LIST_ROW, AppListRow);
	_tmp0_ = self->priv->_app_id;
	_tmp1_ = g_desktop_app_info_new (_tmp0_);
	_tmp2_ = _tmp1_;
	app_list_row_set_app_info (self, _tmp2_);
	_g_object_unref0 (_tmp2_);
	_tmp3_ = self->priv->_app_info;
	_tmp4_ = g_app_info_get_icon ((GAppInfo*) _tmp3_);
	_tmp5_ = _g_object_ref0 (_tmp4_);
	icon = _tmp5_;
	_tmp6_ = gtk_icon_theme_get_default ();
	theme = _tmp6_;
	_tmp7_ = theme;
	_tmp8_ = icon;
	_tmp9_ = gtk_icon_theme_lookup_by_gicon (_tmp7_, _tmp8_, 32, GTK_ICON_LOOKUP_USE_BUILTIN);
	_tmp10_ = _tmp9_;
	_tmp11_ = _tmp10_ == NULL;
	_g_object_unref0 (_tmp10_);
	if (_tmp11_) {
		GThemedIcon* _tmp12_;
		_tmp12_ = (GThemedIcon*) g_themed_icon_new ("application-default-icon");
		_g_object_unref0 (icon);
		icon = (GIcon*) _tmp12_;
	}
	_tmp13_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp13_);
	image = _tmp13_;
	_tmp14_ = image;
	_tmp15_ = icon;
	g_object_set (_tmp14_, "gicon", _tmp15_, NULL);
	_tmp16_ = image;
	gtk_image_set_pixel_size (_tmp16_, 32);
	_tmp17_ = self->priv->_app_info;
	_tmp18_ = g_app_info_get_display_name ((GAppInfo*) _tmp17_);
	_tmp19_ = (GtkLabel*) gtk_label_new (_tmp18_);
	g_object_ref_sink (_tmp19_);
	name_label = _tmp19_;
	_tmp20_ = name_label;
	gtk_label_set_ellipsize (_tmp20_, PANGO_ELLIPSIZE_END);
	_tmp21_ = name_label;
	gtk_label_set_xalign (_tmp21_, (gfloat) 0);
	_tmp22_ = self->priv->_app_info;
	_tmp23_ = g_app_info_get_description ((GAppInfo*) _tmp22_);
	gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp23_);
	_tmp24_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp24_);
	grid = _tmp24_;
	_tmp25_ = grid;
	gtk_grid_set_column_spacing (_tmp25_, 12);
	_tmp26_ = grid;
	_tmp27_ = image;
	gtk_container_add ((GtkContainer*) _tmp26_, (GtkWidget*) _tmp27_);
	_tmp28_ = grid;
	_tmp29_ = name_label;
	gtk_container_add ((GtkContainer*) _tmp28_, (GtkWidget*) _tmp29_);
	_tmp30_ = grid;
	g_object_set ((GtkWidget*) _tmp30_, "margin", 6, NULL);
	_tmp31_ = grid;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp31_, 18);
	_tmp32_ = grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp32_);
	_g_object_unref0 (grid);
	_g_object_unref0 (name_label);
	_g_object_unref0 (image);
	_g_object_unref0 (icon);
	return obj;
}

static void
app_list_row_class_init (AppListRowClass * klass,
                         gpointer klass_data)
{
	app_list_row_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &AppListRow_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_app_list_row_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_app_list_row_set_property;
	G_OBJECT_CLASS (klass)->constructor = app_list_row_constructor;
	G_OBJECT_CLASS (klass)->finalize = app_list_row_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_LIST_ROW_APP_ID_PROPERTY, app_list_row_properties[APP_LIST_ROW_APP_ID_PROPERTY] = g_param_spec_string ("app-id", "app-id", "app-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_LIST_ROW_DESKTOP_PATH_PROPERTY, app_list_row_properties[APP_LIST_ROW_DESKTOP_PATH_PROPERTY] = g_param_spec_string ("desktop-path", "desktop-path", "desktop-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_LIST_ROW_APP_INFO_PROPERTY, app_list_row_properties[APP_LIST_ROW_APP_INFO_PROPERTY] = g_param_spec_object ("app-info", "app-info", "app-info", G_TYPE_DESKTOP_APP_INFO, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
app_list_row_instance_init (AppListRow * self,
                            gpointer klass)
{
	self->priv = app_list_row_get_instance_private (self);
}

static void
app_list_row_finalize (GObject * obj)
{
	AppListRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APP_LIST_ROW, AppListRow);
	_g_free0 (self->priv->_app_id);
	_g_free0 (self->priv->_desktop_path);
	_g_object_unref0 (self->priv->_app_info);
	G_OBJECT_CLASS (app_list_row_parent_class)->finalize (obj);
}

GType
app_list_row_get_type (void)
{
	static volatile gsize app_list_row_type_id__volatile = 0;
	if (g_once_init_enter (&app_list_row_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AppListRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) app_list_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AppListRow), 0, (GInstanceInitFunc) app_list_row_instance_init, NULL };
		GType app_list_row_type_id;
		app_list_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "AppListRow", &g_define_type_info, 0);
		AppListRow_private_offset = g_type_add_instance_private (app_list_row_type_id, sizeof (AppListRowPrivate));
		g_once_init_leave (&app_list_row_type_id__volatile, app_list_row_type_id);
	}
	return app_list_row_type_id__volatile;
}

static void
_vala_app_list_row_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	AppListRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_APP_LIST_ROW, AppListRow);
	switch (property_id) {
		case APP_LIST_ROW_APP_ID_PROPERTY:
		g_value_set_string (value, app_list_row_get_app_id (self));
		break;
		case APP_LIST_ROW_DESKTOP_PATH_PROPERTY:
		g_value_set_string (value, app_list_row_get_desktop_path (self));
		break;
		case APP_LIST_ROW_APP_INFO_PROPERTY:
		g_value_set_object (value, app_list_row_get_app_info (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_app_list_row_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	AppListRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_APP_LIST_ROW, AppListRow);
	switch (property_id) {
		case APP_LIST_ROW_APP_ID_PROPERTY:
		app_list_row_set_app_id (self, g_value_get_string (value));
		break;
		case APP_LIST_ROW_DESKTOP_PATH_PROPERTY:
		app_list_row_set_desktop_path (self, g_value_get_string (value));
		break;
		case APP_LIST_ROW_APP_INFO_PROPERTY:
		app_list_row_set_app_info (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

