/* BaseAction.c generated by valac 0.46.10, the Vala compiler
 * generated from BaseAction.vala, do not modify */

/*
* Copyright (c) 2010 Michal Hruby <michal.mhr@gmail.com>
*               2017 elementary LLC.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Michal Hruby <michal.mhr@gmail.com>
*/

#include <glib-object.h>
#include <glib.h>

#define SYNAPSE_TYPE_MATCH (synapse_match_get_type ())
#define SYNAPSE_MATCH(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SYNAPSE_TYPE_MATCH, SynapseMatch))
#define SYNAPSE_MATCH_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SYNAPSE_TYPE_MATCH, SynapseMatchClass))
#define SYNAPSE_IS_MATCH(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SYNAPSE_TYPE_MATCH))
#define SYNAPSE_IS_MATCH_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SYNAPSE_TYPE_MATCH))
#define SYNAPSE_MATCH_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SYNAPSE_TYPE_MATCH, SynapseMatchClass))

typedef struct _SynapseMatch SynapseMatch;
typedef struct _SynapseMatchClass SynapseMatchClass;
typedef struct _SynapseMatchPrivate SynapseMatchPrivate;
typedef enum  {
	SYNAPSE_QUERY_FLAGS_INCLUDE_REMOTE = 1 << 0,
	SYNAPSE_QUERY_FLAGS_UNCATEGORIZED = 1 << 1,
	SYNAPSE_QUERY_FLAGS_APPLICATIONS = 1 << 2,
	SYNAPSE_QUERY_FLAGS_ACTIONS = 1 << 3,
	SYNAPSE_QUERY_FLAGS_AUDIO = 1 << 4,
	SYNAPSE_QUERY_FLAGS_VIDEO = 1 << 5,
	SYNAPSE_QUERY_FLAGS_DOCUMENTS = 1 << 6,
	SYNAPSE_QUERY_FLAGS_IMAGES = 1 << 7,
	SYNAPSE_QUERY_FLAGS_FILES = ((SYNAPSE_QUERY_FLAGS_AUDIO | SYNAPSE_QUERY_FLAGS_VIDEO) | SYNAPSE_QUERY_FLAGS_DOCUMENTS) | SYNAPSE_QUERY_FLAGS_IMAGES,
	SYNAPSE_QUERY_FLAGS_PLACES = 1 << 8,
	SYNAPSE_QUERY_FLAGS_INTERNET = 1 << 9,
	SYNAPSE_QUERY_FLAGS_TEXT = 1 << 10,
	SYNAPSE_QUERY_FLAGS_CONTACTS = 1 << 11,
	SYNAPSE_QUERY_FLAGS_ALL = 0xFFFFFFFFLL,
	SYNAPSE_QUERY_FLAGS_LOCAL_CONTENT = SYNAPSE_QUERY_FLAGS_ALL ^ SYNAPSE_QUERY_FLAGS_INCLUDE_REMOTE
} SynapseQueryFlags;

#define SYNAPSE_TYPE_QUERY_FLAGS (synapse_query_flags_get_type ())

#define SYNAPSE_TYPE_BASE_ACTION (synapse_base_action_get_type ())
#define SYNAPSE_BASE_ACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SYNAPSE_TYPE_BASE_ACTION, SynapseBaseAction))
#define SYNAPSE_BASE_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SYNAPSE_TYPE_BASE_ACTION, SynapseBaseActionClass))
#define SYNAPSE_IS_BASE_ACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SYNAPSE_TYPE_BASE_ACTION))
#define SYNAPSE_IS_BASE_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SYNAPSE_TYPE_BASE_ACTION))
#define SYNAPSE_BASE_ACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SYNAPSE_TYPE_BASE_ACTION, SynapseBaseActionClass))

typedef struct _SynapseBaseAction SynapseBaseAction;
typedef struct _SynapseBaseActionClass SynapseBaseActionClass;
typedef struct _SynapseBaseActionPrivate SynapseBaseActionPrivate;
enum  {
	SYNAPSE_BASE_ACTION_0_PROPERTY,
	SYNAPSE_BASE_ACTION_DEFAULT_RELEVANCY_PROPERTY,
	SYNAPSE_BASE_ACTION_NOTIFY_MATCH_PROPERTY,
	SYNAPSE_BASE_ACTION_NUM_PROPERTIES
};
static GParamSpec* synapse_base_action_properties[SYNAPSE_BASE_ACTION_NUM_PROPERTIES];

struct _SynapseMatch {
	GObject parent_instance;
	SynapseMatchPrivate * priv;
};

struct _SynapseMatchClass {
	GObjectClass parent_class;
	void (*execute) (SynapseMatch* self, SynapseMatch* match);
	void (*execute_with_target) (SynapseMatch* self, SynapseMatch* source, SynapseMatch* target);
	gboolean (*needs_target) (SynapseMatch* self);
	SynapseQueryFlags (*target_flags) (SynapseMatch* self);
};

struct _SynapseBaseAction {
	SynapseMatch parent_instance;
	SynapseBaseActionPrivate * priv;
};

struct _SynapseBaseActionClass {
	SynapseMatchClass parent_class;
	gboolean (*valid_for_match) (SynapseBaseAction* self, SynapseMatch* match);
	gint (*get_relevancy_for_match) (SynapseBaseAction* self, SynapseMatch* match);
	void (*do_execute) (SynapseBaseAction* self, SynapseMatch* source, SynapseMatch* target);
};

struct _SynapseBaseActionPrivate {
	gint _default_relevancy;
	gboolean _notify_match;
};

static gint SynapseBaseAction_private_offset;
static gpointer synapse_base_action_parent_class = NULL;

GType synapse_match_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SynapseMatch, g_object_unref)
GType synapse_query_flags_get_type (void) G_GNUC_CONST;
GType synapse_base_action_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SynapseBaseAction, g_object_unref)
gboolean synapse_base_action_valid_for_match (SynapseBaseAction* self,
                                              SynapseMatch* match);
static gboolean synapse_base_action_real_valid_for_match (SynapseBaseAction* self,
                                                   SynapseMatch* match);
gint synapse_base_action_get_relevancy_for_match (SynapseBaseAction* self,
                                                  SynapseMatch* match);
static gint synapse_base_action_real_get_relevancy_for_match (SynapseBaseAction* self,
                                                       SynapseMatch* match);
gint synapse_base_action_get_default_relevancy (SynapseBaseAction* self);
void synapse_base_action_do_execute (SynapseBaseAction* self,
                                     SynapseMatch* source,
                                     SynapseMatch* target);
static void synapse_base_action_real_do_execute (SynapseBaseAction* self,
                                          SynapseMatch* source,
                                          SynapseMatch* target);
static void synapse_base_action_real_execute_with_target (SynapseMatch* base,
                                                   SynapseMatch* source,
                                                   SynapseMatch* target);
gboolean synapse_base_action_get_notify_match (SynapseBaseAction* self);
static gboolean synapse_base_action_real_needs_target (SynapseMatch* base);
static SynapseQueryFlags synapse_base_action_real_target_flags (SynapseMatch* base);
SynapseBaseAction* synapse_base_action_construct (GType object_type);
SynapseMatch* synapse_match_construct (GType object_type);
void synapse_base_action_set_default_relevancy (SynapseBaseAction* self,
                                                gint value);
void synapse_base_action_set_notify_match (SynapseBaseAction* self,
                                           gboolean value);
static void synapse_base_action_finalize (GObject * obj);
static void _vala_synapse_base_action_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_synapse_base_action_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
synapse_base_action_get_instance_private (SynapseBaseAction* self)
{
	return G_STRUCT_MEMBER_P (self, SynapseBaseAction_private_offset);
}

static gboolean
synapse_base_action_real_valid_for_match (SynapseBaseAction* self,
                                          SynapseMatch* match)
{
	gboolean _tmp0_ = FALSE;
	g_critical ("Type `%s' does not implement abstract method `synapse_base_action_valid_for_match'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return _tmp0_;
}

gboolean
synapse_base_action_valid_for_match (SynapseBaseAction* self,
                                     SynapseMatch* match)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return SYNAPSE_BASE_ACTION_GET_CLASS (self)->valid_for_match (self, match);
}

static gint
synapse_base_action_real_get_relevancy_for_match (SynapseBaseAction* self,
                                                  SynapseMatch* match)
{
	gint _tmp0_;
	gint result = 0;
	g_return_val_if_fail (match != NULL, 0);
	_tmp0_ = self->priv->_default_relevancy;
	result = _tmp0_;
	return result;
}

gint
synapse_base_action_get_relevancy_for_match (SynapseBaseAction* self,
                                             SynapseMatch* match)
{
	g_return_val_if_fail (self != NULL, 0);
	return SYNAPSE_BASE_ACTION_GET_CLASS (self)->get_relevancy_for_match (self, match);
}

static void
synapse_base_action_real_do_execute (SynapseBaseAction* self,
                                     SynapseMatch* source,
                                     SynapseMatch* target)
{
	g_critical ("Type `%s' does not implement abstract method `synapse_base_action_do_execute'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
synapse_base_action_do_execute (SynapseBaseAction* self,
                                SynapseMatch* source,
                                SynapseMatch* target)
{
	g_return_if_fail (self != NULL);
	SYNAPSE_BASE_ACTION_GET_CLASS (self)->do_execute (self, source, target);
}

static void
synapse_base_action_real_execute_with_target (SynapseMatch* base,
                                              SynapseMatch* source,
                                              SynapseMatch* target)
{
	SynapseBaseAction * self;
	gboolean _tmp0_;
	self = (SynapseBaseAction*) base;
	synapse_base_action_do_execute (self, source, target);
	_tmp0_ = self->priv->_notify_match;
	if (_tmp0_) {
		g_signal_emit_by_name (source, "executed");
	}
}

static gboolean
synapse_base_action_real_needs_target (SynapseMatch* base)
{
	SynapseBaseAction * self;
	gboolean result = FALSE;
	self = (SynapseBaseAction*) base;
	result = FALSE;
	return result;
}

static SynapseQueryFlags
synapse_base_action_real_target_flags (SynapseMatch* base)
{
	SynapseBaseAction * self;
	SynapseQueryFlags result = 0U;
	self = (SynapseBaseAction*) base;
	result = SYNAPSE_QUERY_FLAGS_ALL;
	return result;
}

SynapseBaseAction*
synapse_base_action_construct (GType object_type)
{
	SynapseBaseAction * self = NULL;
	self = (SynapseBaseAction*) synapse_match_construct (object_type);
	return self;
}

gint
synapse_base_action_get_default_relevancy (SynapseBaseAction* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_default_relevancy;
	return result;
}

void
synapse_base_action_set_default_relevancy (SynapseBaseAction* self,
                                           gint value)
{
	g_return_if_fail (self != NULL);
	if (synapse_base_action_get_default_relevancy (self) != value) {
		self->priv->_default_relevancy = value;
		g_object_notify_by_pspec ((GObject *) self, synapse_base_action_properties[SYNAPSE_BASE_ACTION_DEFAULT_RELEVANCY_PROPERTY]);
	}
}

gboolean
synapse_base_action_get_notify_match (SynapseBaseAction* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_notify_match;
	return result;
}

void
synapse_base_action_set_notify_match (SynapseBaseAction* self,
                                      gboolean value)
{
	g_return_if_fail (self != NULL);
	if (synapse_base_action_get_notify_match (self) != value) {
		self->priv->_notify_match = value;
		g_object_notify_by_pspec ((GObject *) self, synapse_base_action_properties[SYNAPSE_BASE_ACTION_NOTIFY_MATCH_PROPERTY]);
	}
}

static void
synapse_base_action_class_init (SynapseBaseActionClass * klass,
                                gpointer klass_data)
{
	synapse_base_action_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SynapseBaseAction_private_offset);
	((SynapseBaseActionClass *) klass)->valid_for_match = (gboolean (*) (SynapseBaseAction*, SynapseMatch*)) synapse_base_action_real_valid_for_match;
	((SynapseBaseActionClass *) klass)->get_relevancy_for_match = (gint (*) (SynapseBaseAction*, SynapseMatch*)) synapse_base_action_real_get_relevancy_for_match;
	((SynapseBaseActionClass *) klass)->do_execute = (void (*) (SynapseBaseAction*, SynapseMatch*, SynapseMatch*)) synapse_base_action_real_do_execute;
	((SynapseMatchClass *) klass)->execute_with_target = (void (*) (SynapseMatch*, SynapseMatch*, SynapseMatch*)) synapse_base_action_real_execute_with_target;
	((SynapseMatchClass *) klass)->needs_target = (gboolean (*) (SynapseMatch*)) synapse_base_action_real_needs_target;
	((SynapseMatchClass *) klass)->target_flags = (SynapseQueryFlags (*) (SynapseMatch*)) synapse_base_action_real_target_flags;
	G_OBJECT_CLASS (klass)->get_property = _vala_synapse_base_action_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_synapse_base_action_set_property;
	G_OBJECT_CLASS (klass)->finalize = synapse_base_action_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_BASE_ACTION_DEFAULT_RELEVANCY_PROPERTY, synapse_base_action_properties[SYNAPSE_BASE_ACTION_DEFAULT_RELEVANCY_PROPERTY] = g_param_spec_int ("default-relevancy", "default-relevancy", "default-relevancy", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_BASE_ACTION_NOTIFY_MATCH_PROPERTY, synapse_base_action_properties[SYNAPSE_BASE_ACTION_NOTIFY_MATCH_PROPERTY] = g_param_spec_boolean ("notify-match", "notify-match", "notify-match", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
synapse_base_action_instance_init (SynapseBaseAction * self,
                                   gpointer klass)
{
	self->priv = synapse_base_action_get_instance_private (self);
	self->priv->_notify_match = TRUE;
}

static void
synapse_base_action_finalize (GObject * obj)
{
	SynapseBaseAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SYNAPSE_TYPE_BASE_ACTION, SynapseBaseAction);
	G_OBJECT_CLASS (synapse_base_action_parent_class)->finalize (obj);
}

GType
synapse_base_action_get_type (void)
{
	static volatile gsize synapse_base_action_type_id__volatile = 0;
	if (g_once_init_enter (&synapse_base_action_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SynapseBaseActionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) synapse_base_action_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SynapseBaseAction), 0, (GInstanceInitFunc) synapse_base_action_instance_init, NULL };
		GType synapse_base_action_type_id;
		synapse_base_action_type_id = g_type_register_static (SYNAPSE_TYPE_MATCH, "SynapseBaseAction", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		SynapseBaseAction_private_offset = g_type_add_instance_private (synapse_base_action_type_id, sizeof (SynapseBaseActionPrivate));
		g_once_init_leave (&synapse_base_action_type_id__volatile, synapse_base_action_type_id);
	}
	return synapse_base_action_type_id__volatile;
}

static void
_vala_synapse_base_action_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	SynapseBaseAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SYNAPSE_TYPE_BASE_ACTION, SynapseBaseAction);
	switch (property_id) {
		case SYNAPSE_BASE_ACTION_DEFAULT_RELEVANCY_PROPERTY:
		g_value_set_int (value, synapse_base_action_get_default_relevancy (self));
		break;
		case SYNAPSE_BASE_ACTION_NOTIFY_MATCH_PROPERTY:
		g_value_set_boolean (value, synapse_base_action_get_notify_match (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_synapse_base_action_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	SynapseBaseAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SYNAPSE_TYPE_BASE_ACTION, SynapseBaseAction);
	switch (property_id) {
		case SYNAPSE_BASE_ACTION_DEFAULT_RELEVANCY_PROPERTY:
		synapse_base_action_set_default_relevancy (self, g_value_get_int (value));
		break;
		case SYNAPSE_BASE_ACTION_NOTIFY_MATCH_PROPERTY:
		synapse_base_action_set_notify_match (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

